#include <crtdbg.h>
#include <stdlib.h>

int main()
{
	// BLOC 1
	int BreakAlloc=-1   ;
	_CrtSetBreakAlloc(BreakAlloc);
	// FIN BLOC 1

	{
		int* a = malloc(sizeof(int));
		//free(a);
	}

	// BLOC 2
	_CrtDumpMemoryLeaks();
	// FIN BLOC 2
	return 0;
}

/*!F
Si vous faites marcher ce code, vous le trouverez tres utile.
Il sert a traquer les fuites mmoire.
(marche uniquement en mode debug)

Test sous Visual C++ 6.0 et Visual 2005 .Net, Viusual 2008 .Net
Il doit tres bien marcher sous les environnements Windows (devC++, Code::blocks entre autres)

Si vous lancez le programme comme a, il ne se passera pas grand chose.

Mettez un breakpoint sur la ligne :
_CrtSetBreakAlloc(BreakAlloc);

Lancez le programme en debug : il s'arrete sur cette ligne.
Faite le terminer en debug.

Dans la fenetre output du compilateur, il s'affiche une ligne ayant cette allure :

{58} normal block at 0x004316D0, 4 bytes long.
Data: < > CD CD CD CD 

	  En fait, le programme vous dit qu'une allocation de 4 octets n'a pas t libre, et surtout, il vous dit que son identifiant est 58.
	  (vous pourrez avoir n'importe quel identifiant)
	  Notez cet identifiant quelque part.

	  Puis relancez le programme SANS RECOMPILER.

	  Il s'arrete sur la ligne :
	  _CrtSetBreakAlloc(BreakAlloc);

grace a votre breakpoint.
Maintenant, ditez la variable BreakAlloc, puis remplacez par le nombre not (pour moi 58)
puis lancez a nouveau le programme.

Le programme va s'arreter sur le 
int* a = malloc(sizeof(int));

Voila ! Vous avez trouv ou a t allou la variable non libre.

Si vous aviez activ le free, alors il n'y aurait pas eu ce message.

Conclusion :

Un tuto pas tres pouss, je vous l'accorde.
Dans vos programmes, si vous voulez tester les fuites mmoire, mettez le BLOC1 au dbut de votre main, et BLOC2 a la fin de votre main.
et incluez crtdbg.h
Si le programme comporte des rand(), dsactivez le srand(time(NULL)), le temps du test, pour etre dans le MEME contexte lors des 2 lancements.
En effet, si vous n'etes pas dans le meme contexte, les identifiants n'auront rien a voir...

L'essentiel est que le programme soit execut exactement de la meme maniere les deux fois.

Vous localisez ainsi TOUTES VOS FUITES MEMOIRE



Note : si vous utilisez Visual C++ 2005, vrifiez bien d'etre en configuration MDd (multithreaded Dll DEBUG)
	   et non en MD (multithreaded Dll pas debug). Ou alors en MTd et non en MT.
!*/

/*!E
	No explanations yet.
!*/

/*
titre: Detection des fuites mmoires avec crtdbg.h
titreE: Detecting memory leaks with crtdbg.h
meta: C;fuites mmoires;crtdbg.h
metaE: C;memory leaks;crtdbg.h
desc : Detection des fuites mmoires avec crtdbg.h
descE : Detecting memory leaks with crtdbg.h
cle  : _CrtSetBreakAlloc, _CrtDumpMemoryLeaks
*/
